function[max_c,q,scra]=AtSelTrgOOMP(Re,N,GT,eex,option);

%input
%     Re  Residue of the approximation
%     N   Number of atoms in the  dictionary 
%     case 1 complex exp. 2 Cos dictionary, 3 Sin diciotnary  4 mix Cos U Sin dictionary
%
%output
%     max_c  maximim | Re*D|
%     q indice of the atom maximazing the above 
%     scra value of Re*D for atom q
L= length(Re);
M=N;
switch option
   case 1 
   cc=fft(Re,N)*sqrt(1/L);
   ccno=cc./(sqrt(1-GT));
   [max_c,q]=max(abs(ccno));
   scra=cc(q);
   case 2
    cf=fft(Re,2*M);
%
    cc=real(eex(1,:).*cf(1:M));
    ccno=cc./sqrt((1-GT)).';
   [max_c,q]=max(abs(ccno));
   scra=cc(q);
   case 3
   cf=fft(Re,2*M);
   cf(1)=[];
   cc=-imag(eex(1,:).*cf(1:M));
   ccno=cc./(sqrt(1-GT)).';
   [max_c,q]=max(abs(ccno));
   scra=cc(q);
   case 4
   M=N/2;
   cf=fft(Re,2*M);
   c1=real(eex(1,:).*cf(1:M)) ;
   ccno1=c1./(sqrt(1-(GT(:,1))).');
%
     cf(1)=[];
   c2=-imag(eex(2,:).*cf(1:M));
   ccno2=c2./(sqrt(1-GT(:,2)).');
%
   [max_c1 q1]= max(abs(ccno1));
   [max_c2 q2]= max(abs(ccno2));
   if max_c1 >= max_c2 
    max_c = max_c1;
        q =q1;
      scra=ccno1(q1);
   else
    max_c = max_c2;
      scra=ccno2(q2);
       q=q2+N/2;
   end
   otherwise 
   disp('unknown option');
end
