function[IPLoc]=IPLocDir(Re,hat1,d1);
%Calculate the Inner product with a Dictionary dic of translated prototype hat.
%
%Inputs Re vector to calculate the inner product with 
%       hat prototype
%       dic dictionary of tranlated atoms 
%Outpout IPLoc (innerproduct with all the dictionary atoms

h1=hat1/norm(hat1);% 
sup=numel(h1);
if sup==1
 c1=Re; 
else
c1=conv(Re,h1);
for j=1:sup-1;
c1(j)=c1(j)/norm(d1(:,j))*norm(hat1);
c1(end-j+1)=c1(end-j+1)*norm(hat1)/norm(d1(:,end-j+1));
end
end
IPLoc=c1;


