%Approximation with  Nonlinear DCT ( DCT is the best trigonometric basis).
%
%======================Change the value below to change the example=====================
Clip=1 %to test the other clips change to 2 or 3
%
%=======================================================================================
%
switch Clip
case 1
wavefile='gw151226.wav'
[wave,fs]=audioread(wavefile); %readsignal;
signal=wave(1:2^16,1);
bw=numel(signal);% size of parition unit Nb`
pss=50; %requiered SNR
tol_zero_frame =1e-3; 
case 2
wavefile='iota_20_10000_4_4_90_h.wav'
[wave,fs]=audioread(wavefile);
signal=wave(:,1);
bw=2^14 %(Nb=16384, size of partition unit)
pss=50; %requiered SNR
tol_zero_frame =1e-5;
case 3
wavefile='Black_Hole_Billiards.wav'
[wave,fs]=audioread(wavefile);
signal=wave(:,1);
bw=16384;
pss=40;
tol_zero_frame =1e-5;
   otherwise
   disp('unknown option');
end
%

[s1,s2]=size(signal);
if s1< s2; signal=signal';end
f=signal';
%
%
%
FrameLength=bw;
%
%
s=floor(numel(f)/bw);
mf=f(1:s*bw);%resize the signam to be divisible by bw
Nx=numel(mf);
Nframe=Nx/bw; %number of frames
t0=1;
cmf=cell(Nframe,1);
%

for j=1:Nframe;
t=t0:t0+bw-1;
t0=t0+bw;
cmf{j}=mf(t);
end
%======end the segmentation each cmf is a cell with a farme or size bw===
tic
NBX=Nframe;
delta=1;
%
indx=[]; %do not touch 
%
%
No=bw;
mfc=cell(Nframe,1);
c1=cell(Nframe,1);
nCoe=0;
zero_frame=0;
%
%=============Start the approxiamtion of each block=========
%
clear cc  Di1  h c cDi1  cfb
tic;
nb=[];
cfb=zeros(No,Nframe);
for j=1:Nframe;
tol=sqrt(norm(cmf{j})^2/(10^(pss/10)));
if (norm(cmf{j})^2)*delta>tol_zero_frame %avoids to try and approximate a zero block 
%
[h{j},Di1{j},cc{j}]=NLA_DCT(cmf{j},tol);
%======== save the coefficients and indices and approximated block 
k0=numel(cc{j});
nb=[nb; j*ones(k0,1)];
nCoe = nCoe + k0; %number of coeffients in the frames
else
nCoe = nCoe + 1;     %counts 1 coefficient per zero frame )
num_zero_blocks=zero_frame+1 %numbers of zero frame
h{j}=zeros(bw,1)';
cc{j}=zeros(1,1);
Di1{j}=1;
end
%cfb{j}(Di1{j})=cc{j};
cfb(Di1{j},j)=(cc{j}).^2;
end
toc
%
%=====================================================================
clear msignal
fa=[];
for i=1:Nframe
if size(h{i},1)>size(h{i},2)
h{i}=h{i}';
end
fa=[fa h{i}];%get the whole signal from the  
end
fprintf('===============================================\n')
;
%
 fprintf(' Sparsity Ratio SR.\n');
%
SR= numel(mf)/nCoe% Sparsity ratio
nCoe %numer of atoms
%
 fprintf(' Approximation quality SNR.\n');
%
SNR= CalcSNR(mf,fa)
mean_noise=mean(abs(mf-fa))
var_noise=var(abs(mf-fa))
fprintf('===============================================\n')

return
